/*************************************************************************\
*   				Xcard 1.2				  *
*									  *
* Copyright 1991, Kenneth C. Nelson			 	          *
*									  *
* Rights       : I, Ken Nelson own Xcard.  You may compile, modify, and   *
*                use Xcard.  You may not sell Xcard or anything derived   *
*		 from Xcard in binary or source for more than reasonable  *
*                media costs.                                             *
*                                                                         *
*		 Xcard uses a dynamic object library	   	          *
*		 that I don't own.  See the subdirectory dynobj for  	  *
*		 restrictions on its use.				  *
*								          *
*                Please feel free to modify Xcard. See Todo for details.  *
*									  *
\*************************************************************************/


/*
 * editbody.c - provides the text editor for the card body.
 *
 */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Paned.h> 
#include <X11/Xaw/Box.h> 
#include <X11/Xaw/AsciiText.h> 

/*
 * The widget holding the card body editor.
 */
 
static Widget bodyEditor;
static Widget headerArea;


/*
 * addCardTextEditor() - adds the text viewer used to view the body of the
 *			 cards.
 *			 Returns the Widget it made to do this.
 *
 */

Widget addCardTextEditor(parent)
  Widget parent;
{
  Widget box;

 /*
  * An aciiTextWidget translation that disables carriage returns etc...
  *
  */

  static char oneLineTrans[] =  " Ctrl<Key>M : beginning-of-line()\n \
				 <Key>Return: beginning-of-line() ";


  XtTranslations  oneLineEditor;
  

   box        = XtVaCreateManagedWidget(
					"headerTitleBox",
					boxWidgetClass,
					parent,
					XtNshowGrip,FALSE,
					NULL
				       );
   XawPanedAllowResize(box,FALSE);

   headerArea = XtVaCreateManagedWidget(
					"headerTitleArea",
					asciiTextWidgetClass,
					box,
					XtNeditType,XawtextEdit,
					XtNscrollVertical,XawtextScrollNever,
					XtNwidth,390,
					XtNborderWidth,0,
					NULL
				       );
  oneLineEditor = XtParseTranslationTable(oneLineTrans);
  XtOverrideTranslations(headerArea,oneLineEditor);


   
   bodyEditor = XtVaCreateManagedWidget(
					"bodyEditor",
					asciiTextWidgetClass,
					parent,
					XtNeditType,XawtextEdit,
					XtNheight,300,
					XtNscrollVertical,XawtextScrollAlways,
					NULL
				       );
}




/*
 * setHeaderArea() - sets the header area string, this is write only.
 *
 */

void setHeaderArea(text)
 char *text;
{
   XtVaSetValues(headerArea,XtNstring,text,NULL);
}



/*
 * headerAreaText() - returns the current string in the header editor.
 *
*/

char *headerAreaText()
{
  char *text;

  XtVaGetValues(headerArea,"string",&text,NULL);
  if (text == NULL)
    return "";
  else
    return text;
}


/*
 * setCardEditorText() - sets the text of the viewer to the text provided.
 *
*/

void setCardEditorText(text)
   char	*text;
{
  XtVaSetValues(bodyEditor,XtNstring,text,NULL);
}

/*
 * getCardEditorText() - returns the text the cardviewer is currently viewing.
 *
 *
*/

char *cardEditorText()
{
  char *text;

  XtVaGetValues(bodyEditor,XtNstring,&text,NULL);
  return text;
}


